



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【HDOJ】3316 Mine sweeping</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【HDOJ】3316 Mine sweeping</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 06:28:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>简单BFS。</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;<br />
 #include &lt;cstdio&gt;<br />
 #include &lt;cstring&gt;<br />
 #include &lt;cstdlib&gt;<br />
 #include &lt;queue&gt;<br />
 using namespace std;

 #define MAXN 105

 typedef struct node_t {<br />
     int x, y;<br />
     node_t() {}<br />
     node_t(int xx, int yy) {<br />
         x = xx; y = yy;<br />
     }<br />
 } node_t;

 char map[MAXN][MAXN];<br />
 char ans[MAXN][MAXN];<br />
 bool visit[MAXN][MAXN];<br />
 int dir[][] = {<br />
     {-,},{,},{,},{,-},<br />
     {,},{,-},{-,},{-,-}<br />
 };<br />
 node_t s;<br />
 int n;

 bool check(int x, int y) {<br />
     return x&lt; || x&gt;=n || y&lt; || y&gt;=n;<br />
 }

 void bfs() {<br />
     int i, j, k, tmp;<br />
     int x, y, v;<br />
     int xx[], yy[], m;<br />
     queue&lt;node_t&gt; Q;<br />
     node_t nd;

     memset(visit, false, sizeof(visit));<br />
     memset(ans, '.', sizeof(ans));<br />
     visit[s.x][s.y] = true;<br />
     for (i=; i&lt;n; ++i)<br />
         ans[i][n] = '\0';<br />
     Q.push(s);

     while (!Q.empty()) {<br />
         nd = Q.front();<br />
         Q.pop();<br />
         v = m = ;<br />
         for (i=; i&lt;; ++i) {<br />
             x = nd.x + dir[i][];<br />
             y = nd.y + dir[i][];<br />
             if (check(x, y))<br />
                 continue;<br />
             xx[m] = x;<br />
             yy[m] = y;<br />
             ++m;<br />
             if (map[x][y] == 'X')<br />
                 ++v;<br />
         }<br />
         ans[nd.x][nd.y] = v+'';<br />
         if (v == ) {<br />
             for (i=; i&lt;m; ++i) {<br />
                 if (!visit[xx[i]][yy[i]]) {<br />
                     visit[xx[i]][yy[i]] = true;<br />
                     Q.push(node_t(xx[i], yy[i]));<br />
                 }<br />
             }<br />
         }<br />
     }<br />
 }

 int main() {<br />
     int i, j;

 #ifndef ONLINE_JUDGE<br />
     freopen("data.in", "r", stdin);<br />
 #endif    

     while (scanf("%d", &amp;n) != EOF) {<br />
         for (i=; i&lt;n; ++i)<br />
             scanf("%s", map[i]);<br />
         scanf("%d %d", &amp;s.x, &amp;s.y);

         if (map[s.x][s.y] == 'X') {<br />
             printf("it is a beiju!\n\n");<br />
         } else {<br />
             bfs();<br />
             for (i=; i&lt;n; ++i)<br />
                 printf("%s\n", ans[i]);<br />
             printf("\n");<br />
         }<br />
     }

     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlkl08o.html">CSS笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pmvzq.html">IOS网络第五天 AFN-03-监控网络状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/495znme9.html">Bookstore project using XAMPP 详细配置 Part 2</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m63529.html">【CodeVS】p1079 回家</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y1mgq.html">记录以下boost&colon;&colon;shared&lowbar;ptr的一个使用细节</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16mzj9.html">Android - 封装Fragment不依赖于Activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvppkjq.html">jquery 过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpvo1q.html">qt4&period;8&period;4安装以及64位程序编译方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdngr8.html">Swift - 给表格的单元格UITableViewCell添加图片，详细文本标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxke6g08.html">iOS项目之同时点击多个按钮解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj5rz9.html">UIView的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvem19.html">Linux下memcached安装与连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wp1wzq.html">UVA817-According to Bartjens（DFS）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmw2d8.html">CRM系统（第二部分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3zz18.html">【Codeforces 1120A】Diana and Liana</a>
		</li>
						<li><a href="https://www.batexi.com/a/960krv39.html">IntelliJ IDEA 通过GsonFormat插件将JSONObject格式的String 解析成实体</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zywr619.html">使用libcurl下载https地址的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5vpo7q.html">JVM总结-Java语法糖与Java编译器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26l4y9.html">mysql定位慢查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kom7z3q.html">php&colon;&sol;&sol; &mdash; 访问各个输入&sol;输出流（I&sol;O streams）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mn5rppq.html">&period;NET获取英文月份缩写名&lpar;可获取其他国家&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd2k7d8.html">Object -C &commat;property -- 笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/96or4d39.html">实战&colon;mysql版本号升级</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd7olmq.html">告别LVS：使用keepalived&plus;nginx实现负载均衡代理多个https</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v3nmn8.html">sae storage 使用uploadify插件进行文件批量上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1g7oz9.html">Java基础知识强化92：日期工具类的编写和测试案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v3x748.html">zookeeper笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1zz6n9.html">PL&sol;SQL中文显示都显示成&OpenCurlyDoubleQuote;？&rdquo;的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmr4le9.html">Java直接插入算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m5631q.html">php页面显示空白</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
